﻿local _, ns = ...

local C = ns.C
local L = ns.L

DefaultDB = {
	big = true,
	name = true,
	texture = true,
	daduan = true,
	arrow = true,
	ch = true,
	mytarget = true,
	sf = true,
	pvp = true,
	boom = false,
	bbom = false,
	white = false,
	casttime = true,
	nameonly = false,	--名字模式
	npcname = true,
	dispelbuff = true,
	absnum = true,
	
	
	auto = true,
	killtexture = true,
	bufftext = true,
	po = true,
	hpcent = false,
	DetailType = 3,
	
	namefont = 12,
	num = .8,	--怀旧服默认0.8
	mypotext = 1,
	KillPer = 0,

	hidebuff = false,
	
	blacklist = false,
	
	myplatebuff = true,
	buffz = 25,
	buffoffset = 0,
	SelfScale = 1,
	
	nScale = 1,	--怀旧服默认1
	tScale = 1,
	ov = 0.8,
	oh = 0.6,
	AlphaMult = 1,
	MaxAlpha = 1,
	
color = {
	["rgb0"] = {r=1, g=0, b=0}, 
    ["rgb1"] = {r=1, g=0, b=0}, 
    ["rgb2"] = {r=0.3, g=0, b=0.6},
	["rgb3"] = {r=0.2, g=0.3, b=0.6},
	["rgb4"] = {r=1, g=0.5, b=0},
	["rgb5"] = {r=0, g=1, b=1},
	
	["rgb7"] = {r=1, g=0, b=1},
	
	["rgb11"] = {r=0, g=0, b=1},
	["rgb12"] = {r=1, g=1, b=1},
	["dotrgb"] = {r=1, g=1, b=1},
},

DctAura = {	
	--[307443] = true,	--璀璨火花
	--[307454] = true, 	--璀璨火花易伤

	},
blackAura = {	
	--[307443] = true,	--璀璨火花--黑名单示范

	},
dotcolorAura = {	
	--[307443] = true,	--璀璨火花--黑名单示范

	},
}


----------ONLOAD EVENT---------
local loadFrame = CreateFrame("FRAME"); 
loadFrame:RegisterEvent("ADDON_LOADED"); 
loadFrame:RegisterEvent("PLAYER_LOGOUT"); 

function loadFrame:OnEvent(event, arg1)
	if not PlateColorDB then PlateColorDB = {} end
	for i, j in pairs(DefaultDB) do
		if type(j) == "table" then
			if PlateColorDB[i] == nil then PlateColorDB[i] = {} end
			for k, v in pairs(j) do
				if PlateColorDB[i][k] == nil then
					PlateColorDB[i][k] = v
				end
			end
		else
			if PlateColorDB[i] == nil then PlateColorDB[i] = j end
		end
	end
end
loadFrame:SetScript("OnEvent", loadFrame.OnEvent);
----------------------------------
--进入游戏时加载一些配置
local uicvars = CreateFrame("Frame")
uicvars:RegisterEvent("PLAYER_ENTERING_WORLD")
uicvars:HookScript("OnEvent", function(self, event)

SetCVar("nameplateGlobalScale", PlateColorDB.nScale)
SetCVar("nameplateSelectedScale", PlateColorDB.tScale)
SetCVar("nameplateLargerScale", PlateColorDB.tScale)
SetCVar("nameplateOverlapV", PlateColorDB.ov)
SetCVar("nameplateOverlapH", PlateColorDB.oh)
SetCVar("nameplateOccludedAlphaMult", PlateColorDB.AlphaMult)
SetCVar("nameplateMaxAlpha", PlateColorDB.MaxAlpha)
SetCVar("nameplateMinAlpha", PlateColorDB.MaxAlpha)
SetCVar("nameplateSelfScale", PlateColorDB.SelfScale)


SetCVar("namePlateMinScale", 1)	--距离缩放
SetCVar("namePlateMaxScale", 1)	--距离缩放
SetCVar("nameplateShowFriendlyNPCs",1)	--友方npc

--姓名版始终保持在屏幕内
SetCVar("nameplateOtherTopInset", 0.08)
SetCVar("nameplateOtherBottomInset", 0.1)
SetCVar("nameplateLargeTopInset", 0.08)
SetCVar("nameplateLargeBottomInset", 0.1)

--字体
local fontline = nil
if PlateColorDB.name == true then
fontline = "OUTLINE"
else
fontline = nil
end
local function SetFont(obj, optSize) 
	local fontName, _,fontFlags  = obj:GetFont() 
	obj:SetFont(fontName,optSize,fontline) 
	obj:SetShadowOffset(0, 0) 
end
SetFont(SystemFont_LargeNamePlate,PlateColorDB.namefont)
SetFont(SystemFont_NamePlate,PlateColorDB.namefont) 
SetFont(SystemFont_LargeNamePlateFixed,PlateColorDB.namefont) 
SetFont(SystemFont_NamePlateFixed,PlateColorDB.namefont) 
SetFont(SystemFont_NamePlateCastBar,PlateColorDB.namefont)

--怀旧设置
SetCVar("NamePlateVerticalScale", 1)	--高
SetCVar("NamePlateHorizontalScale",  1)	--宽

if PlateColorDB.nameonly then --仅显示友方
	SetCVar("nameplateShowDebuffsOnFriendly", 0)--不显示友方debuff
	C_NamePlate.SetNamePlateFriendlySize(128,1)--怀旧服友方血条缩小和正式服数值不一样
	SetCVar("nameplateShowOnlyNames", 1)		--开启仅显名字模式
else
	SetCVar("nameplateShowOnlyNames", 0)		--关闭仅显名字模式
end

end)

hooksecurefunc("CompactUnitFrame_OnUpdate", function(frame)
    for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
        local unitFrame = namePlate.UnitFrame
		unitFrame.CastBar.Text:Show()
		unitFrame.CastBar.Text:SetFont(STANDARD_TEXT_FONT,10, "OUTLINE")
	end
end)
local function PCtexture(unitFrame)
if unitFrame:IsForbidden() then return end
if unitFrame.unit:lower():match("nameplate") then
	if PlateColorDB.texture == true then
        unitFrame.healthBar.border:Hide()
        unitFrame.name:SetPoint("BOTTOM", unitFrame.healthBar,"TOP" ,0, 2)
		unitFrame.healthBar:SetPoint("TOPLEFT", unitFrame, 15, -20)
		unitFrame.healthBar:SetPoint("BOTTOMRIGHT", unitFrame, -15, 0)
        unitFrame.LevelFrame:SetPoint("BOTTOMRIGHT", unitFrame.healthBar, "BOTTOMLEFT", 0, -4)
		unitFrame.CastBar.Border:Hide()
		unitFrame.CastBar:SetScale(.96)
		unitFrame.CastBar:SetPoint("TOPLEFT", unitFrame.healthBar, "BOTTOMLEFT", 1, -5)
		if not unitFrame.shadow then
		unitFrame.shadow = CreateFrame("Frame", unitFrame.shadow, unitFrame.healthBar, "BackdropTemplate")
		unitFrame.shadow:SetFrameStrata(unitFrame.healthBar:GetFrameStrata())
		unitFrame.shadow:SetPoint("TOPLEFT", -1.5, 1.5)
		unitFrame.shadow:SetPoint("BOTTOMRIGHT", 1.5, -1.5)
		unitFrame.shadow:SetBackdrop{edgeFile = 'Interface\\Buttons\\WHITE8x8',edgeSize = 1.5}
		unitFrame.shadow:SetBackdropBorderColor(0, 0, 0, 1)
		end
		if UnitIsUnit(unitFrame.displayedUnit, "target") then
		unitFrame.shadow:SetBackdropBorderColor(1, 1, 1, 1)
		else
		unitFrame.shadow:SetBackdropBorderColor(0, 0, 0, 1)
		end
	end

end
end
hooksecurefunc("CompactUnitFrame_UpdateSelectionHighlight", PCtexture)


--仅显模式显示姓名版
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
if not PlateColorDB.nameonly then return end
if GetCVar("nameplateShowOnlyNames") == "0" then return end
if not frame then return end
if frame:IsForbidden() then return end
if UnitIsUnit(frame.unit,"player") then return end
if not string.match(frame.unit,"nameplate") then return end
CompactUnitFrame_SetHideHealth(frame, not UnitCanAttack("player",frame.unit), 1)
end)
--仅显模式友方名字颜色
hooksecurefunc("CompactUnitFrame_UpdateName", function(unitFrame)
if not PlateColorDB.nameonly then return end
if unitFrame:IsForbidden() then return end
if string.match(unitFrame.unit,"nameplate") then

--显示副标题
if not unitFrame.NpcFuntext then
	unitFrame.NpcFuntext = unitFrame:CreateFontString(nil, "ARTWORK")
	unitFrame.NpcFuntext:SetPoint("TOP",unitFrame.name,"BOTTOM",0,0)
	unitFrame.NpcFuntext:SetAlpha(.9)
	unitFrame.NpcFuntext:SetFont(STANDARD_TEXT_FONT, 10, 'OUTLINE')
	unitFrame.NpcFuntext:SetVertexColor(.5,.5,1)
	unitFrame.NpcFuntext:Hide()
end
if unitFrame.NpcFuntext then
	if PlateColorDB.nameonly and PCNpcFun(unitFrame.unit) and not unitFrame.healthBar:IsShown() and unitFrame.name:IsShown() then
		unitFrame.NpcFuntext:SetText(PCNpcFun(unitFrame.unit))
		unitFrame.NpcFuntext:Show()
	else
		unitFrame.NpcFuntext:Hide()
	end
end

if not UnitIsPlayer(unitFrame.unit) then return end
if unitFrame.healthBar:IsShown() then return end
unitFrame.LevelFrame:Hide()	--怀旧服会显示等级框架
local onlyname,_ = Ambiguate(UnitName(unitFrame.unit),"short")
local _,nameplateclass = UnitClass(unitFrame.unit)
if nameplateclass then
color = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[nameplateclass] or RAID_CLASS_COLORS[nameplateclass]
unitFrame.name:SetText(onlyname)
unitFrame.name:SetVertexColor(color.r,color.g,color.b)
end

end
end)

--材质
local function bartexture(unitFrame)
if PlateColorDB.texture == true then
unitFrame.healthBar:SetStatusBarTexture("Interface\\Addons\\PlateColor\\Raid-Bar-Hp-Fill")
end
end

--施法条计时
local function ShowMyCasting(self)
if not PlateColorDB.casttime then return end
if not self.maxValue then return end
if not self.Cooldown  then
	self.Cooldown = self:CreateFontString(nil)
    self.Cooldown:SetFont(SystemFont_Outline_Small:GetFont(), 16, "OUTLINE")	--施法时间文字大小
    self.Cooldown:SetJustifyH("RIGHT")
    self.Cooldown:SetPoint("RIGHT", self, "RIGHT", 0, 0)
elseif self.maxValue-self.value < 0 then
	self.Cooldown:SetText(" ")
elseif UnitCastingInfo(self.unit) then
	self.Cooldown:SetText(format("%.1f",self.maxValue-self.value))
elseif UnitChannelInfo(self.unit) then
	self.Cooldown:SetText(format("%.1f",self.value,0))
else
	self.Cooldown:SetText(" ")
end
end

--斩杀分割线
local zhansha = 0 --斩杀变色和斩杀分割线用
local function barkillper(unitFrame)
local width = unitFrame.healthBar:GetWidth()
local height = unitFrame.healthBar:GetHeight()
local fsid,_,_,_,_,_,_,_,_,fsidtf = GetTalentInfo(1,3,1)	--法师判断第一行第三个天赋
local zsid,_,_,_,_,_,_,_,_,zsidtf = GetTalentInfo(3,1,1)	--战士3行1天赋斩杀35
if PlateColorDB.auto == true then
	if IsSpellKnown(281000) or IsSpellKnown(280735) or IsSpellKnown(330334) or IsSpellKnown(330325) or IsSpellKnown(343294) or ((zsid == 22380 or zsid ==22379 ) and zsidtf) then
	--281000武器斩杀35,280735狂暴斩杀35,330334武器判罪35,330325狂暴判罪35,343294邪DK灵魂收割,173243奥法弹幕橙or IsEquippedItem(173243) 战士35zsid == 22380 or zsid ==22379
	zhansha = 35
	elseif fsid == 22462 and fsidtf == true then	--灼烧之触
	zhansha = 30
	elseif IsSpellKnown(24275) or IsSpellKnown(163201) or IsSpellKnown(5308) or IsSpellKnown(32379) or IsSpellKnown(53351) or IsSpellKnown(320976) or IsSpellKnown(317349) or IsSpellKnown(317485) then
	--24275愤怒之锤,163201武器防斩杀20,5308狂暴斩杀20,32379牧师灭,53351兽王射击夺命,320976生存夺命,317349武器防判罪20,317485狂暴判罪20
	zhansha = 20
	--elseif IsSpellKnown(322109) then	--轮回之触
	--zhansha = 15
	else
	zhansha = 0
	end
else
	zhansha = PlateColorDB.KillPer
end
if not unitFrame.killline then
	unitFrame.killline = unitFrame.healthBar:CreateTexture(nil, "OVERLAY")
	unitFrame.killline:SetSize(2, height)	
	unitFrame.killline:SetTexture("Interface\\Buttons\\WHITE8x8")
else
	unitFrame.killline:SetPoint("LEFT",unitFrame.healthBar,"LEFT",zhansha*width/100, 0)
	if zhansha == 0 or PlateColorDB.killtexture == false or C_NamePlate.GetNamePlateForUnit(unitFrame.unit) == C_NamePlate.GetNamePlateForUnit("player")
	then unitFrame.killline:Hide() else unitFrame.killline:Show() end
end
end
--名字变色
local function platenamecolor(unitFrame)
if unitFrame:IsForbidden() then return end
if not unitFrame.unit then return end
if UnitIsPlayer(unitFrame.unit) then return end
if UnitIsTapDenied(unitFrame.unit)  then return end
if unitFrame.unit:lower():match("nameplate") then
local guid = UnitGUID(unitFrame.unit)
local _, _, _, _, _, id = strsplit("-", guid or "") 

if id == "5925" or id == "105451" or id == "105427" or id == "61245" then 	--图腾
	C_Timer.After(.1,function()  
		unitFrame.healthBar:SetHeight(30)
	end)
end

if id == "27737" or id == "28167" or id == "28169" then 	--怀旧斯坦索姆僵尸
	unitFrame.healthBar:SetAlpha(.2)
else
	unitFrame.healthBar:SetAlpha(1)
end

if PlateColorDB.white then	--白色名字
	unitFrame.name:SetVertexColor(1, 1, 1)
end



end
end

--调用
local namepoint = CreateFrame("Frame")
namepoint:RegisterEvent("NAME_PLATE_UNIT_ADDED")
namepoint:SetScript("OnEvent", function(self, event,frame)
local namePlate = C_NamePlate.GetNamePlateForUnit(frame,false)
local unitFrame = namePlate.UnitFrame
bartexture(unitFrame)
barkillper(unitFrame)
platenamecolor(unitFrame)
PCtexture(unitFrame)	--怀旧边框
--unitFrame.CastBar:HookScript("OnUpdate", ShowMyCasting)	--施法计时
end)
hooksecurefunc("CompactUnitFrame_UpdateName", platenamecolor)

--血条右侧显示箭头
hooksecurefunc("CompactUnitFrame_UpdateSelectionHighlight", function(frame)
if frame:IsForbidden() then return end
if string.match(frame.unit,"nameplate") then
	if not frame.arrow then
		frame.arrow = frame.healthBar:CreateTexture(nil, "ARTWORK")
		frame.arrow:SetTexture("Interface\\Addons\\PlateColor\\media\\blue.tga")		-- 图标路径
		frame.arrow:SetPoint("right", frame.healthBar, "right", 45, 0)				-- 右方箭头位置
		frame.arrow:SetSize(50, 50)										-- 箭头大小
		frame.arrow:Hide()
	end
	if UnitIsUnit(frame.displayedUnit, "target") and PlateColorDB.arrow ==  true then
		frame.arrow:Show()
	else
		frame.arrow:Hide()
	end
	if UnitIsUnit("player", frame.unit) and frame.arrow then
		frame.arrow:Hide()
	end
end
end)

--血条变色
local function PCbarcolor(unitFrame)
if unitFrame:IsForbidden() then return end
if not unitFrame.unit then return end
if UnitIsUnit(unitFrame.unit,"player") then return end
if not UnitIsPlayer(unitFrame.unit) and not UnitIsTapDenied(unitFrame.unit) then
	local threat = UnitThreatSituation("player", unitFrame.unit) or 0
	local reaction = UnitReaction(unitFrame.unit, "player")
	local name = UnitName(unitFrame.unit)
	local me = UnitName("player")
	local pt = UnitIsUnit(unitFrame.unit.."target", me)
	local Cur = UnitHealth(unitFrame.unit)
	local Max = UnitHealthMax(unitFrame.unit)
	local Per = Cur/Max*100 or 0
	local guid = UnitGUID(unitFrame.unit)
	local _, _, _, _, _, id = strsplit("-", guid or "") 
	local combat = UnitAffectingCombat(unitFrame.unit)
	local ispp = UnitPlayerControlled(unitFrame.unit.."target") and not UnitIsPlayer(unitFrame.unit.."target") and "TANK" == UnitGroupRolesAssigned("player")
		if id == "28619" or id == "205999" or id == "205998" or id == "205997" then --28619怀旧服5人本蜘蛛网 205997镜像
			unitFrame.healthBar:SetStatusBarColor(0,1,0)	--绿色
	    elseif ((id == "174773")or (id == "170483")) and pt == true and PlateColorDB.ch == true then
			unitFrame.healthBar:SetStatusBarColor(PlateColorDB.color.rgb2.r,PlateColorDB.color.rgb2.g,PlateColorDB.color.rgb2.b)	--目标是你但是无仇恨预警
		elseif ispp and PlateColorDB.ch == true then
            unitFrame.healthBar:SetStatusBarColor(0,0,0)	-- 当你是坦克并且仇恨是玩家宠物或者土元素
		elseif threat == 3  and PlateColorDB.ch == true then
            unitFrame.healthBar:SetStatusBarColor(PlateColorDB.color.rgb2.r,PlateColorDB.color.rgb2.g,PlateColorDB.color.rgb2.b)	-- 仇恨是你 颜色
		elseif threat == 2 and PlateColorDB.ch == true then
            unitFrame.healthBar:SetStatusBarColor(PlateColorDB.color.rgb3.r,PlateColorDB.color.rgb3.g,PlateColorDB.color.rgb3.b)	--仇恨降低  颜色
        elseif threat == 1 and PlateColorDB.ch == true then      
            unitFrame.healthBar:SetStatusBarColor(PlateColorDB.color.rgb4.r,PlateColorDB.color.rgb4.g,PlateColorDB.color.rgb4.b)	-- 高仇恨  颜色
		elseif reaction >= 5 then
			unitFrame.healthBar:SetStatusBarColor(0, 1, 0)		-- 友方npc 绿色
		elseif Per <=  zhansha then 
			unitFrame.healthBar:SetStatusBarColor(PlateColorDB.color.rgb7.r,PlateColorDB.color.rgb7.g,PlateColorDB.color.rgb7.b)	--斩杀
		elseif UnitIsUnit(unitFrame.unit, "target") and PlateColorDB.mytarget == true then
			unitFrame.healthBar:SetStatusBarColor(PlateColorDB.color.rgb5.r,PlateColorDB.color.rgb5.g,PlateColorDB.color.rgb5.b)	-- 你的目标 颜色
		elseif combat == true then
			unitFrame.healthBar:SetStatusBarColor(PlateColorDB.color.rgb1.r,PlateColorDB.color.rgb1.g,PlateColorDB.color.rgb1.b)	--战斗状态
		elseif reaction == 4 then
			unitFrame.healthBar:SetStatusBarColor(1, 1, 0)		-- 中立怪 黄色
        else
			unitFrame.healthBar:SetStatusBarColor(PlateColorDB.color.rgb0.r,PlateColorDB.color.rgb0.g,PlateColorDB.color.rgb0.b)
        end
end
end
local barcolor = CreateFrame("Frame")
barcolor:RegisterEvent("NAME_PLATE_UNIT_ADDED")
barcolor:RegisterEvent("UNIT_HEALTH")
--barcolor:RegisterEvent("UNIT_AURA")
barcolor:SetScript("OnEvent", function(self, event,frame)
if frame:lower():match("nameplate") then
local namePlate = C_NamePlate.GetNamePlateForUnit(frame,false)
if not namePlate then return end
local unitFrame = namePlate.UnitFrame
	PCbarcolor(unitFrame)
end
end)
hooksecurefunc("CompactUnitFrame_UpdateSelectionHighlight", function(frame)
if not frame.unit then return end
if frame.unit:lower():match("nameplate") then
	PCbarcolor(frame)
end
end)
hooksecurefunc("CompactUnitFrame_UpdateHealthColor", function(frame)
--UNIT_NAME_UPDATE
--UNIT_THREAT_LIST_UPDATE
--UNIT_CONNECTION
if not frame.unit then return end
if frame.unit:lower():match("nameplate") then
	PCbarcolor(frame)
end
end)


---local mytime = C_Timer.NewTicker(0.1,function()
--施法目标
local casttarget = CreateFrame("Frame")
casttarget:RegisterEvent("NAME_PLATE_UNIT_ADDED")
casttarget:RegisterEvent("UNIT_TARGET")
casttarget:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
casttarget:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
casttarget:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
casttarget:RegisterEvent("UNIT_SPELLCAST_DELAYED")
casttarget:RegisterEvent("UNIT_SPELLCAST_FAILED")
casttarget:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
casttarget:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
--casttarget:RegisterEvent("UNIT_SPELLCAST_INTERRUPTIBLE")
--casttarget:RegisterEvent("UNIT_SPELLCAST_NOT_INTERRUPTIBLE")
casttarget:RegisterEvent("UNIT_SPELLCAST_START")
casttarget:RegisterEvent("UNIT_SPELLCAST_STOP")
casttarget:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
casttarget:SetScript("OnEvent", function(self, event)
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
local frame = namePlate.UnitFrame
if frame then
if not frame.unit then return end
local namea = UnitName(frame.unit.."target")
local myname = UnitName("Player")
local players = UnitIsPlayer(frame.unit)
local _, class = UnitClass(frame.unit.."target")
local guid = UnitGUID(frame.unit)
local _, _, _, _, _, id = strsplit("-", guid or "") 
color = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or RAID_CLASS_COLORS[class]
if not frame.ta then
	frame.ta = frame.healthBar:CreateFontString(nil, "ARTWORK")
	frame.ta:SetFont(STANDARD_TEXT_FONT, 13, 'OUTLINE')
	frame.ta:SetPoint("CENTER",frame.healthBar,"TOPRIGHT",5,7)
	frame.ta:Hide()
elseif PlateColorDB.sf == true and players == false then
	--怀旧服全部显示if ( UnitCastingInfo(frame.unit) ~= nil or UnitChannelInfo(frame.unit) ~= nil ) or id == "174773"  then	--and frame.ta:GetText() == myname then
		if color then frame.ta:SetTextColor(color.r, color.g, color.b) end
		frame.ta:SetText(namea)
		frame.ta:Show()
	--else
		--frame.ta:Hide()
	--end
elseif PlateColorDB.pvp == true and players == true and UnitName(frame.unit) ~= UnitName("Player") then
	if color then frame.ta:SetTextColor(color.r, color.g, color.b) end
	frame.ta:SetText(namea)
	if frame.ta:GetText() == myname then
		frame.ta:Show()
	else
		frame.ta:Hide()
	end
else 
	frame.ta:Hide()
end
end
if UnitIsUnit("player", frame.unit) and frame.ta then
	frame.ta:Hide()
end
end
end)


--[[吸收盾
local plateabs = CreateFrame("Frame")
plateabs:RegisterEvent("UNIT_ABSORB_AMOUNT_CHANGED")
plateabs:RegisterEvent("NAME_PLATE_UNIT_ADDED")
plateabs:SetScript("OnEvent", function(self, event,frame)
if not PlateColorDB.absnum then return end
if not UnitCanAttack("player",frame) then return end
if frame:lower():match("nameplate")  then
local namePlate = C_NamePlate.GetNamePlateForUnit(frame,false)
if not namePlate then return end
local unitFrame = namePlate.UnitFrame
if not namePlate.abs then
namePlate.abs = unitFrame.ClassificationFrame:CreateFontString(frame.."absorb", "OVERLAY")
namePlate.abs:SetPoint("RIGHT", unitFrame.healthBar, "LEFT",0,0)
namePlate.abs:SetFont("Fonts\\ARHei.ttf", 18, "OUTLINE")
else
local nameplateabs = UnitGetTotalAbsorbs(frame)
if nameplateabs > 10000 then
	namePlate.abs:SetText(string.format("%.1f",nameplateabs/10000).."w")
elseif nameplateabs > 0 then
	namePlate.abs:SetText(tostring(nameplateabs))
else
	namePlate.abs:SetText("")
end
end
end
end)]]

--被打断在姓名版施法条显示是谁打断
local interrupt = CreateFrame("Frame", nil, UIParent)
interrupt:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
interrupt:SetScript("OnEvent", function(self, event, unit)
if PlateColorDB.daduan == false then return end
local _, subevent, _, sourceGUID, sourceName, sourceFlag, _, destGUID = CombatLogGetCurrentEventInfo()
if (subevent ~= 'SPELL_INTERRUPT') then return end
if (not sourceName) then return end
local onlyname,_ = strsplit("-",sourceName) --Ambiguate(sourceName,"short")
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
local namePlate = namePlate.UnitFrame
if UnitGUID(namePlate.unit) == destGUID then
local _,class = GetPlayerInfoByGUID(""..sourceGUID)
if class then
color = RAID_CLASS_COLORS[class].colorStr
else color = "ffFFFFFF"
end
namePlate.CastBar.Text:SetText(namePlate.CastBar.Text:GetText().."- ".."|c"..color..onlyname.."|r")
end
end
end)

--生命值
local hp = function(namePlateframe)
if namePlateframe:IsForbidden() then return end
if namePlateframe.unit:lower():match("nameplate")  then
local guid = UnitGUID(namePlateframe.unit)
local _, _, _, _, _, id = strsplit("-", guid or "") 
if not namePlateframe.hp then
namePlateframe.hp = namePlateframe.healthBar:CreateFontString(nil, "ARTWORK")
namePlateframe.hp:SetFont(STANDARD_TEXT_FONT, 14, 'OUTLINE')
else

local CurHealth = UnitHealth(namePlateframe.unit)
local MaxHealth = UnitHealthMax(namePlateframe.unit)
local fPer = string.format("%d",(CurHealth/MaxHealth*100)).."%"
local fPerr = string.format("%.1f",(CurHealth/MaxHealth*100)).."%"
local fCur = nil
if CurHealth > 10000 then
		fCur = string.format("%.1f",CurHealth/10000).."w"
	else
		fCur = tostring(CurHealth)
end
if PlateColorDB.hpcent then 
namePlateframe.hp:SetPoint("CENTER",5,0)
else
namePlateframe.hp:SetPoint("RIGHT",0,0)
end
namePlateframe.hp:SetScale(PlateColorDB.num)

if PlateColorDB.DetailType == 1 then
namePlateframe.hp:SetText(fCur)
elseif PlateColorDB.DetailType == 2 then
namePlateframe.hp:SetText(fPer)
elseif PlateColorDB.DetailType == 3 then
namePlateframe.hp:SetText(fPerr)
elseif PlateColorDB.DetailType == 4 then
namePlateframe.hp:SetText(fCur.." - "..fPer)
elseif PlateColorDB.DetailType == 5 then
namePlateframe.hp:SetText(fCur.." - "..fPerr)
end
if PlateColorDB.DetailType ~= 0 and UnitName(namePlateframe.unit) ~= UnitName("Player") then
namePlateframe.hp:Show()
else
namePlateframe.hp:Hide()
end
end
end
end
hooksecurefunc("CompactUnitFrame_UpdateMaxHealth", hp)
hooksecurefunc("CompactUnitFrame_UpdateHealth", hp)

--[[个人资源数值
local powertext = CreateFrame("Frame")
powertext:RegisterEvent("UNIT_POWER_FREQUENT")
powertext:RegisterEvent("NAME_PLATE_UNIT_ADDED")
powertext:SetScript("OnEvent", function(self, event)
local bar = NamePlateDriverFrame:GetClassNameplateManaBar() 
local power = UnitPower("player")
local powermax = UnitPowerMax("player")
if not bar.po and not platecolorselfpowertext and bar then
bar.po = bar:CreateFontString("platecolorselfpowertext", "ARTWORK")
bar.po:SetFont(STANDARD_TEXT_FONT, 14, 'OUTLINE')
bar.po:SetPoint("CENTER",0,-1)
end
if platecolorselfpowertext then
platecolorselfpowertext:SetText(power)
platecolorselfpowertext:SetScale(PlateColorDB.mypotext)
if PlateColorDB.po == true and powermax < 200 and bar then
platecolorselfpowertext:Show()
else
platecolorselfpowertext:Hide()
end

end
end)]]